//////////////////////////////////////////////////////////////////
//
// pwlib_compat.h PWLib compatibility header
//
// This work is published under the GNU Public License (GPL)
// see file COPYING for details.
// We also explicitely grant the right to link this code
// with the OpenH323 library.
//
//////////////////////////////////////////////////////////////////


#ifndef PWLIB_COMPAT_H
#define PWLIB_COMPAT_H "@(#) $Id: pwlib_compat.h,v 1.18 2007/11/27 12:57:27 willamowius Exp $"

#include "ptbuildopts.h"
#include "openh323buildopts.h"

// use at least PWLib Pandora
#if PWLIB_MAJOR == 1
  #if PWLIB_MINOR < 7
    #error "PWLib too old, use at least 1.7.5.2"
  #endif
#endif

// define PTimedMutex for PWLib < 1.9.2
#if PWLIB_MAJOR == 1
  #if PWLIB_MINOR < 9
    #define PTimedMutex PMutex
  #endif
#endif
#if PWLIB_MAJOR == 1
  #if PWLIB_MINOR == 9
    #if PWLIB_BUILD < 2
      #define PTimedMutex PMutex
    #endif
  #endif
#endif

//#if !defined(P_USE_STANDARD_CXX_BOOL) && !defined(P_USE_INTEGER_BOOL)
#ifndef PBoolean
	typedef int PBoolean;
#endif

#ifdef P_DNS
// define hasRDS for PWLib >= 1.11.3
 #if PWLIB_MAJOR == 1
  #if PWLIB_MINOR >= 11
    #if PWLIB_BUILD > 2     
       #define hasRDS 1
    #endif
  #endif
 #endif

// define hasSETENUMSERVERS for PWLib >= 1.9.3
 #if PWLIB_MAJOR == 1
  #if PWLIB_MINOR >= 9
     #define hasSETENUMSERVERS 1
  #endif
 #endif
#endif

#if PWLIB_MAJOR == 1
 #if PWLIB_MINOR == 12
     #define hasRDS 1 
     #define hasSETENUMSERVERS 1    
 #endif
#endif

// for Ptlib v2.x
#ifdef PTLIB_MAJOR 
  #define hasRDS 1 
  #define hasSETENUMSERVERS 1    
#endif

///////////////////////////////////////////////

// OpenH323 version matching
#if OPENH323_MAJOR == 1
    #if OPENH323_MINOR >= 19
     #if OPENH323_MINOR == 19
	   #if OPENH323_BUILD > 0
	   #define OpenH323Factory 1         // OpenH323 Factory Loader Auth
	   #endif
	   #if OPENH323_BUILD > 4
		#ifdef H323_H460
			#define hasH460 1    // H460 support
		#endif
		#define h323v6 1             // Version 6 features
       #endif
     #else // h323plus v1.20
 	   #define OpenH323Factory 1         // OpenH323 Factory Loader Auth 
           #define h323v6 1                  // Version 6 features  
	 #ifdef H323_H460
           #define hasH460 1	             // H460 support 
         #endif
	     #ifdef P_DNS
	       #define hasSRV 1	             // DNS SRV
	     #endif     
        #endif
     #endif	
#endif

#endif
